=begin
#-----------------------------------------------------------------------------
 Dxf_In_v1.15
(c) honoluludesktop 2010

Freely use, and abuse at your own risk. Fitness of use is 
not warranty implied.

Place this file into the "Google SketchUp 8\Plugins" Folder. To use, 
select File, Input Dxf, and point to a Dxf file.  For help, select a file 
to open, and at the options menu, select "Help Options: Get Help"

Dxf_In will attempt to process erroneously, manually edited files as 
long as the group code is in the correct sequence, including files
that Sketchup's import rejects.

09/24/2010 - v 0.38 Alpha, first release 
09/26/2010 - v 0.40 Alpha, fixed arcs, and added error messages.
09/27/2010 - v 0.42 Alpha, fixed arcs, and speed improved.
09/29/2010 - v 0.45 Alpha, blocks, error messages.
09/30/2010 - v 0.50 Beta, added lwpolylines, fixed blocks.
10/03/2010 - v 1.0   Polyline mesh, error messages, minor fixes.
10/10/2010 - v 1.2   Select import scale, and origin.
10/12/2010 - v 1.5   Add face layer, materials, and option menu
10/14/2010 - v 1.6   Corrected metric conversion table
10/15/2010 - v 1.9	 Pointer by component bound corner, colors by
                                 Sketchup color names, or Acad color number.
10/19/2010 - v 1.10 Scaled transformed entities on the pointer.
10/21/2010 - v 1.14 Interface improvements and save user options.
10/27/2010 - v 1.15 Face circle when user option to face polylines.
#-----------------------------------------------------------------------------
=end

require 'sketchup.rb'

def atelier_main_proc()
	model = Sketchup.active_model
	entities = model.active_entities
	definitions = model.definitions
	hdt_load_acad_colors				
	materials = model.materials		
	@color1=[]
	materials.each do |e|
		@color1.push e
	end
	ext_name = ""
	while ext_name != "DXF"
		chosen_file = UI.openpanel("Sélectionner le fichier DXF","", "*.dxf")
		name_parts = chosen_file.split(".")
		ext_name = name_parts[1].upcase
		my_file_name=File.basename(chosen_file)
	end
	@model_origin=true
	@t = Geom::Transformation.scaling(1)
	options_flag=0
	a_values=[]
	s_value=""
	s_value = Sketchup.read_default("honoluludesktop", "values", "Aucun:Centimètres:Du modèle:en faces:par nombre")
	a_values = s_value.split(":")
	units_list=["Mètres","Centimètres","Millimètres","Pouces","Pieds"].join("|")
	model_selection=["Du modèle","A la souris"].join("|")
	convert_selection =["en faces","en arêtes"].join("|")
	import_texture =["par noms","par nombre","par modèle","Aucune"].join("|")
	update_this =["Aucun","Obtenir une mise à jour","Aide","Sauver options"].join("|")
	prompts=["Options d'aide: ","Unité d'import: ","Sélection de l'origine: ","Polylignes: ","Matériaux: "]
	enums=[update_this,units_list, model_selection,convert_selection,import_texture]
	results = inputbox prompts, a_values, enums, my_file_name+" Options"
	return if not results

	case results[0]
	when "Obtenir une mise à jour"
		url = "http://forums.sketchucation.com/viewtopic.php?f=323&t=31186&start=0#p274199"
		UI.openURL("#{url}#")
		return
	when "Aucun"
		#do nothing
	when "Aide"
		UI.messagebox(hdt_help, MB_OK |80)
		return
	when "Sauver options"
		options_flag=1
	end
	case results[1]
	when "Mètres"
		scale_conv=39.3700787 
		scale_sel="Mètres"
	when "Centimètres"
		scale_conv=0.393700787 
		scale_sel="Centimètres"
	when "Millimètres"
		scale_conv=0.0393700787 
		scale_sel="Millimètres"
	when "Pieds"
		scale_conv=12
		scale_sel="Pieds"
	when "Pouces"
		scale_conv=1
		scale_sel="Pouces"
	end
	@t = Geom::Transformation.scaling(scale_conv) 	

	case results[2]
	when "Du modèle"
		@model_origin=true
		origin_sel="Du modèle"
	when "A la souris"
		@model_origin=false
		origin_sel="A la souris"
	end
	case results[3]
	when "en faces"
		@dface_option = 1
		dface_sel="en faces"
	when "en arêtes"
		@dface_option = 0
		dface_sel="en arêtes"
	end
	case results[4]
	when "par noms"
		@material_option = 1
		material_sel="par noms"
	when "par nombre"
		@material_option = 2
		material_sel="par nombre"
	when "par modèle"
		@material_option = 3
		material_sel="par modèle"
	when "Aucune"
		@material_option = 0
		material_sel="Aucune"
	end
	if options_flag == 1
		a_values = ["Aucun",scale_sel,origin_sel,dface_sel,material_sel]
		s_value = a_values.join(":")
		result = Sketchup.write_default("honoluludesktop","values", s_value)
	end
	@count = 0
	@next_off = -1
	@entities_flag = 0
	@block_flag = 0
	@block_ttl = 0
	@polyline_flag = 0
	@lwpolyline_flag = 0
	@polyline_ttl = 0
	@line_flag = 0
	@line_ttl = 0
	@circle_flag = 0
	@circle_ttl = 0
	@arc_flag = 0
	@arc_ttl = 0
	@extrusion_normal = 0
	@dface_flag = 0
	@dface_ttl = 0
	@vertex_flag = 0
	@last_vertex_pt = []
	@last_line = ""
	@vertex_coord = []
	@vertex_pt = []
	@entity = []
	@group_all = []
	@set_polyface = 0
	@insert_names = []
	insert_flag = 0
	@block_layer			
	@block_name
	@block_x = 0.0
	@block_y = 0.0
	@block_z = 0.0
	vector = Geom::Vector3d.new(0,0,1)
	@vector2 = Geom::Vector3d.new(1,0,0 )
	@vector3 = vector.normalize!
	@cancel_unsupported_error_flag = 1
	@cancel_face_error_flag = 1
	@cancel_polyline_error_flag = 1
	@cancel_nested_blk_error = 1
	@entity_layer=nil
	@entity_material=nil
	@set_material = 0
	blk_flag = 0
	count = 0
	this_line = ""
	last_line = ""
	odd_number = 1
	insert_ttl = 0
	count_100 = 0
	count_bar = ""
	ttl_count = 1
	ramFile = []
	@su_colors = []
	@su_colors = Sketchup::Color.names
	aFile = File.open(chosen_file, "r")
	aFile.each_line do |line|						
		count = count +1
		if count == odd_number	
			odd_number = odd_number + 2
			line = line.strip
		end
		last_line = this_line					
		this_line = line
		count_100 = count_100 +1			
		if count_100 == 100
			count_bar = count_bar + "|"
			if count_bar.length == 150
				ttl_count = ttl_count+1
				count_bar = ""
			end
			count_100 = 0
			Sketchup.set_status_text("Etape 1 [  #{ttl_count}  ]: #{count_bar}", SB_PROMPT)
		end
		if line == "BLOCK\n" 								
			blk_flag = 1
			else if line == "ENDBLK\n"
				blk_flag = 0
				else if line == "INSERT\n" and last_line == "0" and blk_flag == 1
					if @cancel_nested_blk_error == 1		
						result = UI.messagebox("Blocs imbriqués non supportés", MB_OKCANCEL)
						if result == 2
							@cancel_nested_blk_error = 0	
						end
					end
					else if line == "INSERT\n" and last_line == "0" and blk_flag == 0
						insert_flag = 1
						else if(last_line == "8" or last_line == "2" or last_line == "10" or last_line == "20" or last_line == "30") and insert_flag == 1
							if last_line == "30"
								insert_flag = 0
							end				
							insert_ttl = insert_ttl + 1
							@insert_names.push(line)
						end
					end
				end
			end
		end
		ramFile.push(line)
	end
	aFile.close
	count = 0
	last_line = ""
	this_line = ""
	@odd_number = 1
	@polyface_flag = 0
	@polyface_cnt_flag = 0
	@lwpline_verticies = 0
	@unsupported_entities = 0
	@bad_faces = 0
	count_100 = 0
	count_bar = ""
	cnt_count = 1
	@master_group = entities.add_group
	@block_group = @master_group.entities.add_group
	ramFile.each do |@line|					
		@count = @count + 1	
		@last_line = this_line		
		this_line = @line			
		count_100 = count_100 +1		
		if count_100 == 100
			count_bar = count_bar + "|"
			if count_bar.length == 150
				cnt_count = cnt_count+1
				count_bar = ""
			end
			count_100 = 0
			Sketchup.set_status_text("Etape 2 [ #{cnt_count}/#{ttl_count} ]: #{count_bar}", SB_PROMPT)
		end
		if @line == "BLOCK\n" 							
			@block_flag = 1															
			@block_group = @master_group.entities.add_group
			else if @line == "ENDBLK\n" 									
				@block_flag = 0														
				@block_group.name = @block_name						
				if @block_layer != "0" and @block_layer != nil		
					new_layer = Sketchup.active_model.layers.add(@block_layer.to_s)
					@block_group.layer = new_layer
				end
				else if @line == "ENTITIES\n"					
					@entities_flag = 1
					else if @line == "ENDSEC\n" and @entities_flag == 1
						@entities_flag = 0									
						else if @last_line == "70" and @line.to_f == 64 
							@polyface_flag = 1
							else if @block_flag == 1
								hdt_block_in()											
								else if @block_flag == 0 and @entities_flag == 1
									hdt_entities_in()										
								end
							end
						end
					end
				end
			end
		end
	end															
	if @polyline_ttl+@line_ttl+@dface_ttl+@arc_ttl+@circle_ttl == 0
		UI.messagebox("<Erreur> ou fichier vide")
		return
	end	
	if @model_origin == false									
		my_instance = @master_group.to_component
		my_definition = my_instance.definition
		my_definition.entities.transform_entities(@t,my_definition.entities.to_a)
		bb=my_instance.bounds									
	 	my_definition.name = my_file_name				
		my_definition.insertion_point = bb.corner(0)	
		select = UI.messagebox("Blocs | Groupes            :  "+ @block_ttl.to_s+"\n\nEntités non supportées:  "+@unsupported_entities.to_s+"\nFaces incorrectes         :  "+@bad_faces.to_s+"\n\nArêtes connectées       :  "+@polyline_ttl.to_s+"\nFaces                            :  "+@dface_ttl = @dface_ttl.to_s+"\nLignes                           :  "+@line_ttl.to_s+"\nArcs                              :  "+@arc_ttl.to_s+"\nCercles                         :  "+@circle_ttl.to_s+ "\n\nDxf Entités à localiser", MB_OK  |80)
		my_instance.erase!							
		model.place_component my_definition		
	else
		@master_group.transform! @t				
		select = UI.messagebox("Blocs | Groupes            :  "+ @block_ttl.to_s+"\n\nEntités non supportées:  "+@unsupported_entities.to_s+"\nFaces incorrectes         :  "+@bad_faces.to_s+"\n\nArêtes connectées       :  "+@polyline_ttl.to_s+"\nFaces                            :  "+@dface_ttl = @dface_ttl.to_s+"\nLignes                           :  "+@line_ttl.to_s+"\nArcs                              :  "+@arc_ttl.to_s+"\nCercles                         :  "+@circle_ttl.to_s+ "\n\nDxf Entités à localiser", MB_OK  |80)
		if select == 7 													
			@master_group.explode
		else 															
			if @master_group.name == ""						
				@master_group.name = my_file_name
			end
		end
	end

end

def hdt_block_in()														
	if @last_line == "2"
		insert_names_line = -1
		@block_name = ""
		@block_x = 0.0
		@block_y = 0.0
		@block_z = 0.0
		@insert_names.each do |insert_vari|			
			insert_names_line = insert_names_line + 1
			if insert_vari == @line
				@block_ttl = @block_ttl + 1
				@block_layer = @insert_names[insert_names_line-1].strip
				@block_name = @insert_names[insert_names_line].strip
				@block_x = @insert_names[insert_names_line+1].to_f
				@block_y = @insert_names[insert_names_line+2].to_f
				@block_z = @insert_names[insert_names_line+3].to_f
				if  @polyface_flag == 1 and @block_name != "AME_NIL"
					@polyface_flag = 0
					if @cancel_unsupported_error_flag == 1
						@unsupported_entities = @unsupported_entities +1
						result = UI.messagebox("Bloc "+@block_name+" contient un maillage non supporté     ", MB_OKCANCEL)
						if result == 2
							@cancel_unsupported_error_flag = 0
						end
					end
				end
				@polyface_flag = 0				
			end
		end
	end
	if @block_name != ""
		hdt_entities_in()
	end
end

def hdt_circle_in
	if @last_line == "10" or @last_line == "20" or @last_line == "30" or @last_line == "40"
		@entity.push(@line.to_f)
		if @last_line == "40"
			@circle_ttl = @circle_ttl + 1
			@circle_flag = 0
			if @block_flag == 1			
				group = @block_group.entities.add_circle([@entity[0]+@block_x, @entity[1]+@block_y, @entity[2]+@block_z], @vector3, @entity[3])
				if @dface_option == 1
					group = @block_group.entities.add_face(group.to_a)
				end
			else											
				group = @master_group.entities.add_circle([@entity[0]+@block_x, @entity[1]+@block_y, @entity[2]+@block_z], @vector3, @entity[3])
				if @dface_option == 1
					group = @master_group.entities.add_face(group.to_a)
				end
			end
			@entity.clear
		end
	end
end

def hdt_arc_in
	if @last_line == "230"					
		if @line == "-1.0\n"
			@extrusion_normal = 1
		else 
			@extrusion_normal = 0
		end
		else if @last_line == "10" or @last_line == "20" or @last_line == "30" or @last_line == "40" or @last_line == "50" or @last_line == "51" 
			@entity.push @line.to_f
			if @last_line == "51"
				@arc_ttl = @arc_ttl + 1
				@arc_flag = 0
				if @block_flag == 1			
					if @entity[5] == 0.0 or @entity[5] < @entity[4]
						@entity[5] = @entity[5]+360.0
					end			
					if @extrusion_normal != 1	
						group = @block_group.entities.add_arc([@entity[0]+@block_x, @entity[1]+@block_y, @entity[2]+@block_z],@vector2,@vector3,@entity[3],(@entity[4]*Math::PI)/180,((@entity[5])*Math::PI)/180)
					else									
						group = @block_group.entities.add_arc([(1.5*-@entity[0])+@block_x, -@entity[1]+@block_y,-@entity[2]+@block_z],@vector2,@vector3,@entity[3],((90+@entity[4])*Math::PI)/180,((90+@entity[5])*Math::PI)/180)
					end
				else										
					if @entity[5] == 0.0 or @entity[5] < @entity[4]
						@entity[5] = @entity[5]+360.0
					end			
					if @extrusion_normal != 1
						group = @master_group.entities.add_arc([@entity[0]+@block_x, @entity[1]+@block_y, @entity[2]+@block_z],@vector2,@vector3,@entity[3],(@entity[4]*Math::PI)/180,((@entity[5])*Math::PI)/180)
					else										
						group = @master_group.entities.add_arc([(1.5*-@entity[0])+@block_x, -@entity[1]+@block_y,-@entity[2]+@block_z],@vector2,@vector3,@entity[3],((90+@entity[4])*Math::PI)/180,((90+@entity[5])*Math::PI)/180)
					end
				end
				@entity.clear
			end
		end
	end
end

def hdt_dface_in
	hdt_get_layer_material
	else if @last_line == "10" or @last_line == "20" or @last_line == "30" or @last_line == "11" or @last_line == "21" or @last_line == "31" or @last_line == "12" or @last_line == "22" or @last_line == "32" or @last_line == "13" or @last_line == "23" or @last_line == "33"
		@entity.push @line.to_f
		if @last_line == "33"
			@dface_ttl = @dface_ttl + 1
			@dface_flag = 0
			if @block_flag == 1
				begin
					ent_group = @block_group.entities.add_face([@entity[0]+@block_x,@entity[1]+@block_y,@entity[2]+@block_z],[@entity[3]+@block_x,@entity[4]+@block_y,@entity[5]+@block_z],[@entity[6]+@block_x,@entity[7]+@block_y, @entity[8]+@block_z],[@entity[9]+@block_x,@entity[10]+@block_y,@entity[11]+@block_z])
					hdt_put_layer_material(ent_group)			
				rescue
					type = "Bloc noms "+@block_name+" 3DFace incorrecte  "
					hdt_database_error(type)
				end
			else
				begin
					ent_group = @master_group.entities.add_face([@entity[0]+@block_x,@entity[1]+@block_y,@entity[2]+@block_z],[@entity[3]+@block_x,@entity[4]+@block_y,@entity[5]+@block_z],[@entity[6]+@block_x,@entity[7]+@block_y, @entity[8]+@block_z],[@entity[9]+@block_x,@entity[10]+@block_y,@entity[11]+@block_z])
					hdt_put_layer_material(ent_group)
				rescue
					type = " 3DFace incorrecte  "
					hdt_database_error(type)
				end
			end
			@entity.clear
		end
	end
end

def hdt_polyline_in
	hdt_get_layer_material
	if @line == "VERTEX\n" and @last_line == "0"
		@vertex_flag = 1
		else if(@last_line == "10" or @last_line == "20" or @last_line == "30") and @vertex_flag == 1
			@vertex_pt.push(@line.to_f)
			if @last_line == "30" and @last_vertex_pt != [@vertex_pt[0],@vertex_pt[1],@vertex_pt[2]] and @vertex_flag == 1
				if [@vertex_pt[0],@vertex_pt[1],@vertex_pt[2]] == [0.0,0.0,0.0] and @polyface_flag == 1
					if @set_polyface == 0
						result = UI.messagebox("Maillage polyface non supporté",MB_OKCANCEL)
						
						if result == 2
							@set_polyface = 1
						end
					end
				else									
					@last_vertex_pt = [@vertex_pt[0],@vertex_pt[1],@vertex_pt[2]]
					@vertex_coord.push([@vertex_pt[0] + @block_x, @vertex_pt[1] + @block_y, @vertex_pt[2] + @block_z])
				end
				@vertex_pt.clear
				@vertex_flag = 0
			end
			else if @line == "SEQEND\n"
				@polyline_flag = 0
				@last_vertex_pt.clear
				if	@dface_option == 0 and not @vertex_coord.empty? 
					@polyline_ttl = @polyline_ttl + 1
					if @block_flag == 1
						group = @block_group.entities.add_edges(@vertex_coord)
					else								
						group = @master_group.entities.add_edges(@vertex_coord)
					end
					else if @dface_option == 1 and not @vertex_coord.empty?	
						@dface_ttl = @dface_ttl + 1
						if @block_flag == 1	
							begin							
								this_face = @block_group.entities.add_face(@vertex_coord	)
								hdt_put_layer_material(this_face)
							rescue
								type = "Bloc noms "+@block_name+" Polyligne incorrecte  "
								hdt_database_error(type)
							end
						else		
							begin
								group = @master_group.entities.add_face(@vertex_coord)
								hdt_put_layer_material(group)
								rescue
								@dface_ttl = @dface_ttl - 1
								if @cancel_polyline_error_flag == 1
									selection = UI.messagebox("<Erreur> Polyligne incorrecte", MB_OKCANCEL)
									if selection == 2
										@cancel_polyline_error_flag = 0
									end
								end
							end
						end
					end
				end
				@vertex_coord.clear
			end
		end
	end
end

def hdt_lwpolyline_in
	if @last_line == "90"
		@lwpline_verticies = @line.to_f
		else if @last_line == "10" or @last_line == "20"
			@vertex_pt.push(@line.to_f)
			if @last_line == "20" 
				@lwpline_verticies = @lwpline_verticies - 1
				@vertex_coord.push([@vertex_pt[0] + @block_x, @vertex_pt[1] + @block_y, 0.0 + @block_z])
				@vertex_pt.clear
			end
			else if 	@lwpline_verticies == 0 or @line == "0"	
				if not @vertex_coord.empty?
					@polyline_ttl = @polyline_ttl + 1
					@lwpolyline_flag = 0
					@lwpline_verticies = 0
					if @block_flag == 1			
						group = @block_group.entities.add_edges(@vertex_coord)
					else										
						group = @master_group.entities.add_edges(@vertex_coord)
					end
				end
				@vertex_coord.clear
			end
		end
	end
end

def hdt_line_in
	if @last_line == "10" or @last_line == "20" or @last_line == "30" or @last_line == "11" or @last_line == "21" or @last_line == "31"
		@entity.push @line.to_f				
		if @last_line == "31"					
			@line_ttl = @line_ttl + 1			
			@line_flag = 0						
			if @block_flag == 1				
				group = @block_group.entities.add_line([@entity[0]+@block_x, @entity[1]+@block_y, @entity[2]+@block_z], [@entity[3]+@block_x,@entity[4]+@block_y, @entity[5]+@block_z])
			else											
				group = @master_group.entities.add_line([@entity[0]+@block_x, @entity[1]+@block_y, @entity[2]+@block_z], [@entity[3]+@block_x,@entity[4]+@block_y, @entity[5]+@block_z])
			end
			@entity.clear
		end
	end
end

def hdt_entities_in									
	if @line == "LINE\n" and @last_line == "0"	
		@line_flag = 1							
		else if @line_flag == 1
			hdt_line_in()
			else if @line == "LWPOLYLINE\n" and @last_line == "0"
				@lwpolyline_flag = 1
				else if @lwpolyline_flag == 1
					hdt_lwpolyline_in()
					else if @line == "POLYLINE\n" and @last_line == "0"
						@polyline_flag = 1
						else if @polyline_flag == 1
							hdt_polyline_in()
							else if @line == "3DFACE\n" and @last_line == "0"
								@dface_flag = 1
								else if @dface_flag == 1
									hdt_dface_in()
									else if @line == "CIRCLE\n" and @last_line == "0"
										@circle_flag = 1
										else if @circle_flag == 1
											hdt_circle_in()
											else if @line == "ARC\n" and @last_line == "0"
												@arc_flag = 1
												else if @arc_flag == 1
													hdt_arc_in()
												end
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

def hdt_get_layer_material
	if @last_line == "8"
		@entity_layer = @line.strip
		model = Sketchup.active_model  
		layers = model.layers 
		layer_flag = false
		layers.each do |layer|
			if @entity_layer == layer
				layer_flag = true
			end
		end
		if layer_flag == false
			layers.add(@entity_layer.to_s)
		end
		else if @last_line == "62"			
			@entity_material = @line.strip	
			if @material_option == 2		
				@set_material = 1				
			end
		end
	end
end

def hdt_put_layer_material(ent_group)
	ent_group.layer = @entity_layer		
	if @material_option == 0 					
		#do nothing
		else if @material_option == 1 	
			@su_colors.each do |ea_color|
				if ea_color == @entity_material
					color = Sketchup::Color.new(@entity_material)
					ent_group.material = color
				end
			end
			else if @material_option == 2  and @entity_material.to_i < 256  and @set_material == 1
				@acad_colors.each do |eacolor|
					if eacolor[0] == @entity_material.to_i	
						color = Sketchup::Color.new([eacolor[1],eacolor[2],eacolor[3]])
						ent_group.material = color 
					end
				end
				@set_material = 0						
				else if @material_option == 3 	
					@color1.each do |mcolor|
						if mcolor.display_name == @entity_material
							color = Sketchup::Color.new(mcolor.color)
							ent_group.material = color
						end
					end
				end
			end
		end
	end
end

def hdt_database_error(type)
	@dface_ttl = @dface_ttl - 1
	@bad_faces = @bad_faces + 1
	if @cancel_face_error_flag == 1
		selection = UI.messagebox("<Erreur>"+type, MB_OKCANCEL)
		if selection == 2
			@cancel_face_error_flag = 0
		end
	end
end

def hdt_load_acad_colors
	@acad_colors = [[0,0,0,0],[1,255,0,0],[2,255,255,0],[3,0,255,0],[4,0,255,255],[5,0,0,255],[6,255,0,255],[7,255,255,255],
	[8,65,65,65],[9,128,128,128],[10,255,0,0],[11,255,170,170],[12,189,0,0],[13,189,126,126],[14,129,0,0],[15,129,86,86],
	[16,104,0,0],[17,104,69,69],[18,79,0,0],[19,79,53,53],[20,255,63,0],[21,255,199,170],[22,189,46,0],[23,189,131,126],
	[24,129,31,0],[25,129,96,86],[25,104,25,0],[27,104,78,69],[28,79,19,0],[29,79,59,53],[30,255,127,0],[31,255,212,170],
	[32,189,94,0],[33,189,157,126],[32,189,94,0],[33,189,157,126],[34,129,64,0],[35,129,107,86],[36,104,52,0],[37,104,86,69],
	[38,79,39,0],[38,79,39,0],[39,79,66,53],[40,255,191,0],[41,255,234,170],[42,189,141,0],[43,189,173,126],[44,129,96,0],
	[45,129,118,86],[46,104,78,0],[47,104,95,69],[48,79,59,0],[49,79,73,53],[50,255,255,0],[51,255,255,170],[52,189,189,0],
	[53,189,189,126],[54,129,129,86],[55,129,129,86],[56,104,104,0],[57,104,104,69],[58,79,79,0],[59,79,79,53],[60,191,255,0],
	[61,234,255,170],[62,141,189,0],[63,173,189,126],[64,96,129,0],[65,118,129,86],[66,78,104,0],[67,95,104,69],[68,59,79,0],
	[69,73,79,53],[70,127,255,0],[71,212,255,170],[72,94,189,0],[73,157,189,126],[74,64,129,0],[75,107,129,86],[76,52,104,0],
	[77,86,104,69],[78,39,79,0],[79,66,79,53],[80,63,255,0],[81,191,255,170],[82,46,189,0],[83,141,189,126],[84,31,129,0],
	[85,96,129,86],[86,25,104,0],[87,78,104,69],[88,19,79,0],[89,59,79,53],[90,0,255,0],[91,170,255,170],[92,0,189,0],
	[93,126,189,126],[94,0,129,0],[95,86,129,86],[96,0,104,0],[97,69,104,69],[98,0,79,0],[99,53,79,53],[100,0,255,63],
	[101,170,255,191],[102,0,189,46],[103,126,189,141],[104,0,129,31],[105,86,129,96],[106,0,104,25],[107,69,104,78],
	[108,0,79,19],[109,53,79,59],[110,0,255,127],[111,170,255,212],[112,0,189,94],[113,126,189,157],[114,0,129,64],
	[115,86,129,107],[116,0,104,52],[117,69,104,86],[118,0,79,39],[119,53,79,66],[120,0,255,191],[121,170,255,234],
	[122,0,189,141],[123,126,189,173],[124,0,129,96],[125,86,129,118],[126,0,104,78],[127,69,104,95],[128,0,79,59],
	[129,53,79,73],[130,0,255,255],[131,170,255,255],[132,0,189,189],[133,126,189,189],[134,0,129,129],[135,86,129,129],
	[136,0,104,104],[137,69,104,104],[138,0,79,79],[139,53,79,79],[140,0,191,255],[141,170,234,255],[142,0,141,189],
	[143,126,173,189],[144,0,96,129],[145,86,118,129],[146,0,78,104],[147,69,95,104],[148,0,59,79],[149,53,73,79],
	[150,0,127,255],[151,170,212,255],[152,170,212,255],[153,126,157,189],[154,0,64,129],[155,86,107,129],[156,0,52,104],
	[157,69,86,104],[158,0,39,79],[159,53,66,79],[160,0,63,255],[161,170,191,255],[162,0,46,189],[163,126,141,189],
	[164,0,31,129],[165,86,96,129],[166,0,25,104],[167,69,78,104],[168,0,19,79],[169,53,59,79],[170,0,0,255],[171,170,170,255],
	[172,0,0,189],[173,126,126,189],[174,0,0,129],[175,86,86,129],[176,0,0,104],[177,69,69,104],[178,0,0,79],[179,53,53,79],
	[180,63,0,255],[181,191,170,255],[182,46,0,189],[183,141,126,189],[184,31,0,129],[185,96,86,129],[186,25,0,104],
	[187,78,69,104],[188,19,0,79],[189,59,53,79],[190,127,0,255],[191,212,170,255],[192,94,0,189],[193,157,126,189],
	[194,64,0,129],[195,107,86,129],[196,52,0,104],[197,86,69,104],[198,39,0,79],[199,66,53,79],[200,191,0,255],
	[201,234,170,255],[202,141,0,189],[203,173,126,189],[204,96,0,129],[205,118,86,129],[206,78,0,104],[207,95,69,104],
	[208,59,0,79],[209,73,53,79],[210,255,0,255],[211,255,170,255],[212,189,0,189],[213,189,126,189],[214,129,0,129],
	[215,129,86,129],[216,104,0,104],[217,104,69,104],[218,79,0,79],[219,79,53,79],[220,255,0,191],[221,255,170,234],
	[222,189,0,141],[223,189,126,173],[224,129,0,96],[225,129,86,118],[226,104,0,78],[227,104,69,95],[228,79,0,59],
	[229,79,53,73],[230,255,0,127],[231,255,170,212],[232,189,0,94],[233,189,126,157],[234,129,0,64],[235,129,86,107],
	[236,104,0,52],[237,104,69,86],[238,79,0,39],[239,79,53,66],[240,255,0,63],[241,255,170,191],[242,189,0,46],
	[243,189,126,141],[244,129,0,31],[245,129,86,96],[246,104,0,25],[247,104,69,78],[248,79,0,19],[249,79,53,59],
	[250,51,51,51],[251,80,80,80],[252,105,105,105],[253,130,130,130],[254,190,190,190],[255,255,255,255]]
end

def hdt_help 
	"
	LES ENTITES DXF SUPPORTEES SONT:
		 
	 1.  Polylignes comme arêtes connectées.
	 2.  Polyligne's (fermées) comme faces sélectionnées par l'utilisateur.
	 3.  LWPolylignes comme arêtes connectées.
	 5.  Lignes comme arêtes.
	 6.  Cercles comme contour d'arêtes.
	 7.  Arcs comme contour d'arêtes.
	 8.  3dFaces comme faces.
	 9.  Blocs comme groupes ou composants.
	10. Maillage Polyligne comme arêtes.
	11. Maillage comme faces sélectionnées.
		
	Les blocs sont convertis en groupes ou composants. Les calques sont préservés, et
	le nom des groupes ou composants est le nom du fichier DXF. Les noms des blocs
	sont conforme à l'original. Les blocs imbriqués ne sont pas pris en charge.

	Les faces ont leur calque et matériau (voir ci-dessous). Les 3DFaces et
	les polylignes fermées (option par défaut) sont importées comme des faces. Les trous
	internes à des faces sont remplis par défaut, l'utilisateur doit inspecter le modèle 
	et les effacer manuellement.
		
	CALQUES ET MATERIAUX: L'option d'import par défaut des faces
	conserve les noms des calques et lescouleurs Autocad deviennent des
	matériaux. Les options de matériau supportent les noms de base des matériaux
	SketchUp, ou les noms de matériaux du modèle courant. 
	Fixer l'option ""matériau"" à ""Aucun"" si besoin.

	L'origine du modèle est préservée, ou l'utilisateur peut choisir l'origine de l'import.
	L'origine du modèle place l'import à l'origine de SketchUp.Ceci est utile dans le
	cas où le modèle CAD et SketchUp sont identiques.
		
	LES ENTITES GEOMETRIQUES NON SUPPORTEES comprennent les maillages
	polyfaces, (blocs imbriqués), les polylignes lissées et de largeur non nulle.
	Si vous désirez convertir des entités non supportées, décomposez-les avant
	d'exporter le DXF.
		
	LES MESSAGES D'ERREUR peuvent être annulés.Lorsqu' applicable et si possible,
	l'application ignorera le problème et n'affichera plus d'autres messages.

	LES OPTIONS D'AIDE incluent la sauvegarde des options utilisateur sélectionnées."

end

unless file_loaded? File::basename(__FILE__)
	add_separator_to_menu("File")	
    UI.menu("File").add_item("Importer DXF") { atelier_main_proc }
    file_loaded File::basename(__FILE__)
end

